//all the functions in here are the ones that do all the grunt work of actually telling the server and/or clients about what needs to happen
//all the functions in here are the ones that do all the grunt work of actually telling the server and/or clients about what needs to happen
//all the functions in here are the ones that do all the grunt work of actually telling the server and/or clients about what needs to happen
//all the functions in here are the ones that do all the grunt work of actually telling the server and/or clients about what needs to happen
//all the functions in here are the ones that do all the grunt work of actually telling the server and/or clients about what needs to happen
//all the functions in here are the ones that do all the grunt work of actually telling the server and/or clients about what needs to happen
//all the functions in here are the ones that do all the grunt work of actually telling the server and/or clients about what needs to happen


#include <extdll.h>		//always

#include <string.h> //to prevent linux errors while processing meta_api.h
#include <sdk_util.h>	//pre-defined function definitions saves us a lot of work

//#include <api_info.h>		// api_info_t, etc
#include <meta_api.h>		// Plugin_info, etc

#include <cbase.h>

#include "plugin.h"
#include "utilfunctions.h"


//decided to just fukkit and add all the headers that show up in the hlsdk util.cpp
#include <gamerules.h>
#include <saverestore.h>
#include <time.h>
#include <shake.h>
#include <decals.h>
#include <player.h>
//#include <weapons.h>

DLL_GLOBAL const Vector     g_vecZero = Vector(0,0,0);

int gmsgTextMsg = 0;
int gmsgSayText = 0;

//=========================================================
// UTIL_LogPrintf - Prints a logged message to console.
// Preceded by LOG: ( timestamp ) < message >
//=========================================================
void UTIL_LogPrintf( char *fmt, ... )
{
	va_list			argptr;
	static char		string[1024];
	
	va_start ( argptr, fmt );
	vsprintf ( string, fmt, argptr );
	va_end   ( argptr );

	// Print to server console
	ALERT( at_logged, "%s", string );
}


// returns a CBaseEntity pointer to a player by index.  Only returns if the player is spawned and connected
// otherwise returns NULL
// Index is 1 based
CBaseEntity	*UTIL_PlayerByIndex( int playerIndex )
{
	CBaseEntity *pPlayer = NULL;

	if ( playerIndex > 0 && playerIndex <= gpGlobals->maxClients )
	{
		edict_t *pPlayerEdict = INDEXENT( playerIndex );
		if ( pPlayerEdict && !pPlayerEdict->free )
		{
			pPlayer = CBaseEntity::Instance( pPlayerEdict );	
		}
	}
	
	return pPlayer;
}

int UTIL_GetPlayerIndex( CBasePlayer *pPlayer ) {
	if(pPlayer == NULL) return 0;
	int counter;
	for(counter = 1; counter <= gpGlobals->maxClients; counter++) {
		if(pPlayer == UTIL_PlayerByIndex(counter)) return counter;
	}
	return 0;
}


void UTIL_HudMessage(CBaseEntity *pEntity, const hudtextparms_t &textparms, const char *pMessage)
{
	
	//if ( !pEntity || !pEntity->IsNetClient() ) //original version of line below that made plugin crash under linux
	if ( !pEntity )
		return;

	MESSAGE_BEGIN( MSG_ONE, SVC_TEMPENTITY, NULL, pEntity->pev ); 
		WRITE_BYTE( TE_TEXTMESSAGE );
		WRITE_BYTE( textparms.channel & 0xFF );

		WRITE_SHORT( FixedSigned16( textparms.x, 1<<13 ) );
		WRITE_SHORT( FixedSigned16( textparms.y, 1<<13 ) );
		WRITE_BYTE( textparms.effect );

		WRITE_BYTE( textparms.r1 );
		WRITE_BYTE( textparms.g1 );
		WRITE_BYTE( textparms.b1 );
		WRITE_BYTE( textparms.a1 );

		WRITE_BYTE( textparms.r2 );
		WRITE_BYTE( textparms.g2 );
		WRITE_BYTE( textparms.b2 );
		WRITE_BYTE( textparms.a2 );

		WRITE_SHORT( FixedUnsigned16( textparms.fadeinTime, 1<<8 ) );
		WRITE_SHORT( FixedUnsigned16( textparms.fadeoutTime, 1<<8 ) );
		WRITE_SHORT( FixedUnsigned16( textparms.holdTime, 1<<8 ) );

		if ( textparms.effect == 2 )
			WRITE_SHORT( FixedUnsigned16( textparms.fxTime, 1<<8 ) );

		if ( strlen( pMessage ) < 512 )
		{
			WRITE_STRING( pMessage );
		}
		else
		{
			char tmp[512];
			strncpy( tmp, pMessage, 511 );
			tmp[511] = 0;
			WRITE_STRING( tmp );
		}
	MESSAGE_END();
}


void UTIL_HudMessageAll_New(const hudtextparms_t &textparms, const char *pMessage)
{
	
	MESSAGE_BEGIN( MSG_ALL, SVC_TEMPENTITY, NULL ); 
		WRITE_BYTE( TE_TEXTMESSAGE );
		WRITE_BYTE( textparms.channel & 0xFF );

		WRITE_SHORT( FixedSigned16( textparms.x, 1<<13 ) );
		WRITE_SHORT( FixedSigned16( textparms.y, 1<<13 ) );
		WRITE_BYTE( textparms.effect );

		WRITE_BYTE( textparms.r1 );
		WRITE_BYTE( textparms.g1 );
		WRITE_BYTE( textparms.b1 );
		WRITE_BYTE( textparms.a1 );

		WRITE_BYTE( textparms.r2 );
		WRITE_BYTE( textparms.g2 );
		WRITE_BYTE( textparms.b2 );
		WRITE_BYTE( textparms.a2 );

		WRITE_SHORT( FixedUnsigned16( textparms.fadeinTime, 1<<8 ) );
		WRITE_SHORT( FixedUnsigned16( textparms.fadeoutTime, 1<<8 ) );
		WRITE_SHORT( FixedUnsigned16( textparms.holdTime, 1<<8 ) );

		if ( textparms.effect == 2 )
			WRITE_SHORT( FixedUnsigned16( textparms.fxTime, 1<<8 ) );

		if ( strlen( pMessage ) < 512 )
		{
			WRITE_STRING( pMessage );
		}
		else
		{
			char tmp[512];
			strncpy( tmp, pMessage, 511 );
			tmp[511] = 0;
			WRITE_STRING( tmp );
		}
	MESSAGE_END();
}

void UTIL_ClientPrint( entvars_t *client, int msg_dest, const char *msg_name, 
		  const char *param1, const char *param2, const char *param3, 
		  const char *param4 ) {
  
	SAFE_USER_MSG(gmsgTextMsg, "TextMsg", -1);

	MESSAGE_BEGIN( MSG_ONE, gmsgTextMsg, NULL, client );
	WRITE_BYTE( msg_dest );
	WRITE_STRING( msg_name );

	if ( param1 )
	WRITE_STRING( param1 );

	if ( param2 )
	WRITE_STRING( param2 );

	if ( param3 )
	WRITE_STRING( param3 );

	if ( param4 )
	WRITE_STRING( param4 );

	MESSAGE_END();

}

void UTIL_SayText( const char *pText, CBaseEntity *pEntity )
{
	
	//if ( !pEntity->IsNetClient() ) //this line crashes hudmessage under linux, so i assume it will do the same here but never bothered to test
	//	return;

	SAFE_USER_MSG(gmsgSayText, "SayText", -1 );

	MESSAGE_BEGIN( MSG_ONE, gmsgSayText, NULL, pEntity->edict() );
		WRITE_BYTE( pEntity->entindex() );
		WRITE_STRING( pText );
	MESSAGE_END();
}

void UTIL_SayTextAll( const char *pText, CBaseEntity *pEntity )
{
	MESSAGE_BEGIN( MSG_ALL, gmsgSayText, NULL );
		WRITE_BYTE( pEntity->entindex() );
		WRITE_STRING( pText );
	MESSAGE_END();
}

CBaseEntity *UTIL_FindEntityInSphere( CBaseEntity *pStartEntity, const Vector &vecCenter, float flRadius )
{
	edict_t	*pentEntity;

	if (pStartEntity)
		pentEntity = pStartEntity->edict();
	else
		pentEntity = NULL;

	pentEntity = FIND_ENTITY_IN_SPHERE( pentEntity, vecCenter, flRadius);

	if (!FNullEnt(pentEntity))
		return CBaseEntity::Instance(pentEntity);
	return NULL;
}



CBaseEntity *UTIL_FindEntityByString( CBaseEntity *pStartEntity, const char *szKeyword, const char *szValue )
{
	edict_t	*pentEntity;

	if (pStartEntity)
		pentEntity = pStartEntity->edict();
	else
		pentEntity = NULL;

	pentEntity = FIND_ENTITY_BY_STRING( pentEntity, szKeyword, szValue );

	if (!FNullEnt(pentEntity))
		return CBaseEntity::Instance(pentEntity);
	return NULL;
}


void UTIL_ParticleImplosion_All( Vector origin, unsigned char radius, unsigned char count, unsigned char lifespan ) {
	MESSAGE_BEGIN(MSG_ALL, SVC_TEMPENTITY, NULL);
    WRITE_BYTE(TE_IMPLOSION);
    WRITE_COORD(origin.x);
    WRITE_COORD(origin.y);
    WRITE_COORD(origin.z);
	WRITE_BYTE( radius );
	WRITE_BYTE( count );
	WRITE_BYTE( lifespan );
    MESSAGE_END();
}

void UTIL_TraceLine( const Vector &vecStart, const Vector &vecEnd, IGNORE_MONSTERS igmon, IGNORE_GLASS ignoreGlass, edict_t *pentIgnore, TraceResult *ptr )
{
	TRACE_LINE( vecStart, vecEnd, (igmon == ignore_monsters ? TRUE : FALSE) | (ignoreGlass?0x100:0), pentIgnore, ptr );
}


void UTIL_TraceLine( const Vector &vecStart, const Vector &vecEnd, IGNORE_MONSTERS igmon, edict_t *pentIgnore, TraceResult *ptr )
{
	TRACE_LINE( vecStart, vecEnd, (igmon == ignore_monsters ? TRUE : FALSE), pentIgnore, ptr );
}

void UTIL_MakeVectors( const Vector &vecAngles )
{
	MAKE_VECTORS( vecAngles );
}


unsigned char UTIL_NSPlayerSpecies( CBasePlayer *pPlayer ) {
	if(pPlayer->pev->team == 0) return 0;
	char szModelName[100];
	strcpy(szModelName, (g_engfuncs.pfnInfoKeyValue((*g_engfuncs.pfnGetInfoKeyBuffer)(pPlayer->edict()), "model")));
	if(FStrEq(szModelName, "commander") || FStrEq(szModelName, "soldier") || FStrEq(szModelName, "heavy")) return 1;
	else return 2;
}

CBaseEntity *FindEntityForward( CBaseEntity *pMe )
{
	TraceResult tr;

	UTIL_MakeVectors(pMe->pev->v_angle);
	UTIL_TraceLine(pMe->pev->origin + pMe->pev->view_ofs,pMe->pev->origin + pMe->pev->view_ofs + gpGlobals->v_forward * 8192,dont_ignore_monsters, pMe->edict(), &tr );
	if ( tr.flFraction != 1.0 && !FNullEnt( tr.pHit) )
	{
		CBaseEntity *pHit = CBaseEntity::Instance( tr.pHit );
		return pHit;
	}
	return NULL;
}


void EMIT_SOUND_DYN(edict_t *entity, int channel, const char *sample, float volume, float attenuation,
						   int flags, int pitch)
{
	EMIT_SOUND_DYN2(entity, channel, sample, volume, attenuation, flags, pitch);
}

void EMIT_SOUND_PLAYER(edict_t *entity, const char *sample, float fVolume )
{
	EMIT_SOUND_DYN2(entity, CHAN_STATIC, sample, fVolume, ATTN_NORM, 0, 100);
}

// play a specific sentence over the HEV suit speaker - just pass player entity, and !sentencename

void EMIT_SOUND_SUIT(edict_t *entity, const char *sample)
{
	float fvol;
	int pitch = PITCH_NORM;

	fvol = CVAR_GET_FLOAT("suitvolume");
	if (RANDOM_LONG(0,1))
		pitch = RANDOM_LONG(0,6) + 98;

	if (fvol > 0.05)
		EMIT_SOUND_DYN(entity, CHAN_STATIC, sample, fvol, ATTN_NORM, 0, pitch);
}


//MAJOR thanks to Hullu for letting me rip and adapt his unstuck pro code for this
void UTIL_PutPlayerInOpenSpace( CBasePlayer *pPlayer ) {
	char model[100];
	int usehull = 0;
	strcpy(model, (g_engfuncs.pfnInfoKeyValue((*g_engfuncs.pfnGetInfoKeyBuffer)(pPlayer->edict()), "model")) );
	if(model[0] == 'a' && model[1] == 'l' && model[2] == 'i' && model[3] == 'e' && model[4] == 'n')
	{
		int model_5 = model[5];
	
		if((model_5=='1' || model_5=='2' || model_5=='3') && model[6]==0)
		{
			//Small aliens (always duck hull)
			usehull = (int)head_hull;
		}
		else if(model_5=='4' && model[6]==0)
		{
			//Check if ducking
			usehull = ( pPlayer->pev->flags & FL_DUCKING ) ? (int)head_hull : (int)human_hull;
		}
		else if(model_5=='5' && model[6]==0)
		{
			//Check if onos ducking
			usehull = ( pPlayer->pev->flags & FL_DUCKING ) ? (int)human_hull : (int)large_hull;
		}
		else
		{
			RETURN_META(MRES_IGNORED);
		}
	}
	else if(FStrEq(model,"soldier") || FStrEq(model,"heavy"))
	{
		//Check if ducking
		usehull = ( pPlayer->pev->flags & FL_DUCKING ) ? (int)head_hull : (int)human_hull;
	}
	
	float height;
	float width;
	
	switch(usehull)
	{
		case (int)human_hull:
			height=72.0f;
			width=32.0f;
		break;
		
		case (int)large_hull:
			height=108.0f;
			width=64.0f;
		break;
		
		case (int)head_hull:
		default:
			height=36.0f;
			width=32.0f;
		break;
	}

	height *= 1.5f;
	width *= 1.5f;

	float half_height = height * 0.5f;
	float half_width = width * 0.5f;

	Vector new_origin;
	
	int type = 0;

	for(int i = 0; i < 6*128; ++i)
	{
		float x,y,z;
	
		switch(type++)
		{
			case 0: 
			   	x = half_width + RANDOM_FLOAT(0,half_width);
			   	y = RANDOM_FLOAT(-width,width);
			   	z = RANDOM_FLOAT(-height,height);
			break;
		
			case 1: 
			   	x = -half_width - RANDOM_FLOAT(0,half_width);
			   	y = RANDOM_FLOAT(-width,width);
			   	z = RANDOM_FLOAT(-height,height);
			break;
		
			case 2: 
			   	x = RANDOM_FLOAT(-width,width);
			   	y = half_width + RANDOM_FLOAT(0,half_width);
			   	z = RANDOM_FLOAT(-height,height);
			break;
		
			case 3: 
				x = RANDOM_FLOAT(-width,width);
			   	y = -half_width - RANDOM_FLOAT(0,half_width);
			   	z = RANDOM_FLOAT(-height,height);
			break;
		
			case 4: 
			   	x = RANDOM_FLOAT(-width,width);
			   	y = RANDOM_FLOAT(-width,width);
			   	z = half_height + RANDOM_FLOAT(0,half_height);
			break;
		
			default:
			   	x = RANDOM_FLOAT(-width,width);
			   	y = RANDOM_FLOAT(-width,width);
			   	z = -half_height - RANDOM_FLOAT(0,half_height);
		   
				type = 0;
			break;
		}
	
		new_origin = pPlayer->pev->origin + Vector( x,y,z );
	
		TraceResult tr;

		TRACE_LINE( pPlayer->pev->origin, new_origin, FALSE, NULL, &tr );
	
		if( tr.flFraction >= 0.998f )
		{
			TRACE_HULL( new_origin, new_origin, FALSE, usehull, NULL, &tr );
		
			if(!tr.fStartSolid)
			{
				pPlayer->pev->origin = new_origin;
				break;
			}
		}
	}
}


unsigned short FixedUnsigned16( float value, float scale )
{
	int output;

	output = (int)(value * scale);
	if ( output < 0 )
		output = 0;
	if ( output > 0xFFFF )
		output = 0xFFFF;

	return (unsigned short)output;
}

short FixedSigned16( float value, float scale )
{
	int output;

	output = (int)(value * scale);

	if ( output > 32767 )
		output = 32767;

	if ( output < -32768 )
		output = -32768;

	return (short)output;
}




